import uvicorn
import yaml
from fastapi import FastAPI, Query, HTTPException, Form
from utils.wordle_solver import WordleSolver
from utils.logger import logger
from utils.wordseg import segment_word
import random

app = FastAPI()
solver = WordleSolver()
seed_word_mapping = {}


@app.post("/wordseg")
async def wordseg(text: str = Form(...)):
    """
    The `wordseg` function takes in a text string and returns a dictionary containing the segments of
    valid English words found in the text. If no valid segments are found, it raises an HTTPException
    with a status code of 404 and a detail message indicating that no valid English word segments were
    found.
    
    :param text: The `text` parameter is a required string parameter that represents the input text that
    needs to be segmented into English word segments
    :type text: str
    :return: a dictionary with a key "segments" and the value being the list of word segments.
    """
    segments = segment_word(text)

    if not segments:
        raise HTTPException(status_code=404, detail="No valid English word segments found")

    return {"segments": segments}


@app.get("/random")
async def random_guess(
    
        guess: str = Query(None, title="Guess", description="The word guess", min_length=1),
        seed: int = Query(..., title="Seed", description="The seed for randomness"),
        size: int = Query(5, title="Size", description="The size of the word")
):
    """
    The `random_guess` function takes a word guess, a seed for randomness, and a size parameter, and
    returns feedback based on the secret word generated using the seed and the given guess.
    
    :param guess: The `guess` parameter is a string that represents the word guess. It is a required
    parameter and should have a minimum length of 1 character
    :type guess: str
    :param seed: The `seed` parameter is used to initialize the random number generator. By setting a
    specific seed value, you can ensure that the random numbers generated will be the same each time the
    function is called with the same seed value. This can be useful for testing or when you want to
    reproduce the same random
    :type seed: int
    :param size: The `size` parameter determines the size of the word that will be generated as the
    secret word. It has a default value of 5, but you can provide a different value if you want the
    secret word to have a different size
    :type size: int
    :return: the feedback generated by the solver's `get_feedback_check_word` method.
    """
    if guess is None:
        logger.warning("Missing 'guess' parameter in the request.")
        raise HTTPException(status_code=422, detail=[{
            "loc": ["query", "guess"],
            "msg": "field required",
            "type": "value_error.missing"
        }])
    if not solver.check_word(guess):
        logger.warning(f"{guess} is not an English word")
        raise HTTPException(status_code=422, detail=[{
            "loc": ["query", "guess"],
            "msg": "Word not found",
            "type": "value_error.error"
        }])

    random.seed(seed)

    secret_word = solver.generate_random_english_word(size)
    logger.info(f"Generated secret word: {secret_word}")

    feedback = solver.get_feedback_check_word(secret_word, guess)
    logger.info(f"Feedback: {feedback}")

    return feedback

if __name__ == "__main__":
    uvicorn.run(app)


